<?php
/**
 * This file implements the Creative Commons Toolbar plugin for b2evolution. Version 2.1 2005/02/07
 *
 * This file may someday be an official part of the b2evolution project - {@link http://b2evolution.net/}
 * at which time I'll move the brackets to the line below.  Until then, tough. :P
 *
 * b2evolution - {@link http://b2evolution.net/}
 * Released under GNU GPL License - {@link http://b2evolution.net/about/license.html}
 * @copyright (c)2003-2004 by Francois PLANQUE - {@link http://fplanque.net/}
 *
 * @copyright (c)2005 by Daniel Morrison danielmorrison@mac.com
 *
 *  TODO
 *	- Have single-file version ready for b2evo 0.9.1
 *	- Consolidate cc_license code?  Rewrite?
 *  - Have toolbar "sense" license and alter fields when editing old posts.
 *	- Buy the world a Coke
 *
 *  Changes in 2.1
 *	- Fixed RDF output to pass XHTML validation. 
 *
 *  Changes in 2.0
 *	- Moved to Toolbar+Renderer concept
 *  - Added RDF metadata
 *  - Added "Hidden" display option (metadata only)
 *  - Added link to public domain image
 *  - Moved location of 'cc_license' directory to blogs/plugins/
 *  - Wrapped rendered code in <span class="cc_license"></span>
 *
 *  Changes in 1.2
 *	- Added $defaultLicense and $defalutDisplay
 *  - Updated License files to use 2.0 licenses (where appropriate) 
 *
 *  Changes in 1.1
 *	- Added language code to the end of license URLs
 *  - Added rel="license" to output
 *
 */
if( !defined('DB_USER') ) die( 'Please, do not access this page directly.' );

/**
 * Includes:
 */
require_once dirname(__FILE__).'/../toolbar.class.php';
require_once dirname(__FILE__).'/../cc_license/cc_license.php';

/**
 * @package plugins
 */
class creativecommons_Toolbarplugin extends ToolbarPlugin
{
	/**
	 * Defaults.  Change these if you wish!
	 */
	var $defaultLicense = 'Attribution';  // name of License as displayed in popup
	var $defaultDisplay = 'symbols';  // can be 'text' 'standard' 'symbols' or 'nidden'
	
	/**
	 * Should be toolbar be displayed?
	 */
	var $display = true;

	var $code = 'evo_ccom';
	var $name = 'Creative Commons Toolbar';
	var $priority = 50;
	var $short_desc;
	var $long_desc;

	var $license = array();
	
	/**
	 * Constructor
	 *
	 * {@internal creativecommons_Toolbarplugin::creativecommons_Toolbarplugin(-)}} 
	 */
	function creativecommons_Toolbarplugin()
	{
		$this->short_desc = T_('Add Creative Commons Licences to posts.');
		$this->long_desc = T_('Quickly and easily add Creative Commons Licenses to your posts, 
						and display them with the companion Creative Commons renderer plugin.');
		
		$this->license = get_licenses('');
	}


	/**
	 * Display the toolbar
	 *
	 * {@internal creativecommons_Toolbarplugin::render(-)}} 
	 */
	function display()
	{		
		if( !$this->display )
		{	// We don't want to show this toolbar
			return false;
		}


		echo '<div class="edit_toolbar" style="vertical-align: middle;">';
		// CC logo and link
		echo '<a href="http://creativecommons.org"><img src="../plugins/cc_license/logo_trademark.gif" height="20" width="20" alt="Creative Commons" /></a> ';
		
		
		// Licenses
		echo ' <label>License:</label> <select id="ccLicense" name="ccLicense">' . "\n";

		foreach( $this->license as $curLicense )
		{
		    // trim "Creative Commons - " off name to make Select shorter
		    if ( substr( $curLicense->name, 0, 19) == 'Creative Commons - ' )
			$name = substr( $curLicense->name, 19);
		    else
			$name = $curLicense->name;
			
		    echo '<option value="'.$curLicense->uri.'" ';
		    if ( $this->defaultLicense == $name )
			echo ' selected';
		    echo '>'.$name.'</option>' . "\n";
		}
		
		echo '</select>';
		
		// Display choices
		echo ' <label>Display:</label> <select id="ccDisplay" name="ccDisplay">';
		    echo '<option value="text" ';
		    if ( $this->defaultDisplay == 'text' )
			echo ' selected';
		    echo '>Text Only</option>';
		    
		    echo '<option value="standard" ';
		    if ( $this->defaultDisplay == 'standard' )
			echo ' selected';
		    echo '>Standard</option>';
		    
		    echo '<option value="symbols" ';
		    if ( $this->defaultDisplay == 'symbols' )
			echo ' selected';
		    echo '>Symbols</option>';
		    echo '<option value="hidden" ';
		    if ( $this->defaultDisplay == 'hidden' )
			echo ' selected';
		    echo '>Hidden</option>';
		echo '</select>';
		
		// Add Button
		echo ' <input type="button" name="ccAdd" value="Add" onclick="javascript:cc_add();" />';
		
	
		echo '</div>';
		?>
		<script type="text/javascript" language="javascript">
		<!--
		function cc_add() {
		
		    var myField;
		    if (document.getElementById('content') && document.getElementById('content').type == 'textarea') {
			    myField = document.getElementById('content');
		    }
		    else {
			    return false;
		    }

		    var license = document.getElementById('ccLicense').options[document.getElementById('ccLicense').selectedIndex].value;
			var display = document.getElementById('ccDisplay').options[document.getElementById('ccDisplay').selectedIndex].value; 
		    
		    // get language from language select on post
		    var language = document.getElementById('post_locale').options[document.getElementById('post_locale').selectedIndex].value.substring(0,2);
		    if ( language != 'en' ) {
			uri += '/deed.' + language;  // add to uri, if not english.  nonsupported languages return english license
			if ( language == 'zh' )
			    uri += '_TW';  // add this for chinese!
		    }
		    
			// Show license code		    
		    myField.value += '<!-- Creative Commons License ';
			myField.value += 'license:' + license + ' display:' + display;
		    myField.value += ' -->';

		    myField.focus();
		}

		-->
		</script>
		<?php
	}
}

// Register the plugin:
$this->register( new creativecommons_Toolbarplugin() );

?>